#include <gtk/gtk.h>

static void enter_notify_event(GtkWidget *widget, GdkEvent *event)
{
    g_message(__FUNCTION__);
}

static void leave_notify_event(GtkWidget *widget, GdkEvent *event)
{
    g_message(__FUNCTION__);
}

static void button_press_event(GtkWidget *widget, GdkEvent *event)
{
    g_message(__FUNCTION__);
    g_message("-----------");
}

int main(int argc, char *argv[])
{
    GtkWidget *window, *darea;

    gtk_init(&argc, &argv);
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    darea = gtk_drawing_area_new();
    gtk_widget_set_events(GTK_WIDGET(darea),
			  GDK_ENTER_NOTIFY_MASK
			  | GDK_LEAVE_NOTIFY_MASK
			  | GDK_BUTTON_PRESS_MASK
			  | GDK_BUTTON_RELEASE_MASK);
    g_signal_connect(G_OBJECT(darea), "button_press_event",
		     G_CALLBACK(button_press_event), NULL);
    g_signal_connect(G_OBJECT(darea), "enter_notify_event",
		     G_CALLBACK(enter_notify_event), NULL);
    g_signal_connect(G_OBJECT(darea), "leave_notify_event",
		     G_CALLBACK(leave_notify_event), NULL);
    gtk_container_add(GTK_CONTAINER(window), darea);
    gtk_widget_show_all(window);
    g_signal_connect(G_OBJECT(window), "destroy",
		     G_CALLBACK(gtk_main_quit), NULL);
    gtk_main();
    return 0;
}
